#include "defs.h"

#include <string.h>

void set_my_name(chat *c, char *n)
{
  c->my_name = strdup(n);
  if (!c->my_name) oom();
}

void set_her_name(chat *c, char *n)
{
  c->her_name = strdup(n);
  if (!c->her_name) oom();
}

int extract_messages(chat *c, char *m)
{
  char *s = m;
  char *t;
  char buf[92];
  int i;
  int nb = 0;

next:
  while (*s) {
    t = strstr(s, "__");
    if (!t) return nb;
    t+=2;
    for (i = 0; i < 92; i++, t++) {
      if (!*t) return nb;
      if (!((*t >= 'a' && *t <= 'z') ||
            (*t >= 'A' && *t <= 'Z') ||
            (*t >= '0' && *t <= '9') ||
             *t == '-' || *t == '.')) { s++; goto next; }
      buf[i] = *t;
    }
    s = t;
    t = decode_message(c, buf);
    if (t) { add_message(c, t); nb++; }
  }
  return nb;
}

static void putbit(char *to, int bit, int v)
{
  int byte;
  int bb;

  if (!v) return;

  byte = bit / 8;
  bb = bit % 8;

  to[byte] |= 1 << (7 - bb);
}

char *decode_message(chat *c, char *m)
{
  static char b[69];
  int i;
  int v;
  int bit = 0;
  char *ret;
  memset(b, 0, 69);
  for (i = 0; i < 92; i++) {
    if (m[i] >= 'a' && m[i] <= 'z') v = m[i] - 'a';
    else if (m[i] >= 'A' && m[i] <= 'Z') v = 26 + m[i] - 'A';
    else if (m[i] >= '0' && m[i] <= '9') v = 26*2 + m[i] - '0';
    else if (m[i] == '-') v = 10+26*2;
    else v = 10+26*2+1;
    putbit(b, bit, (v >> 5) & 1); bit++;
    putbit(b, bit, (v >> 4) & 1); bit++;
    putbit(b, bit, (v >> 3) & 1); bit++;
    putbit(b, bit, (v >> 2) & 1); bit++;
    putbit(b, bit, (v >> 1) & 1); bit++;
    putbit(b, bit, v & 1); bit++;
  }
  ret = decipher(c, b);
  if (!ret || !c->new_message(c, b)) return 0;
  return ret;
}

static int getbit(char *to, int bit)
{
  int byte;
  int bb;

  byte = bit / 8;
  bb = bit % 8;

  if (to[byte] & (1 << (7 - bb))) return 1;
  return 0;
}

char *encode_message(chat *c, char *m)
{
  char *b;
  static char b2[94];
  int bit = 0;
  int i;
  int v;

  b = cipher(c, m);
  for (i = 0; i < 94; i++) {
    v = getbit(b, bit); bit++; v <<= 1;
    v |= getbit(b, bit); bit++; v <<= 1;
    v |= getbit(b, bit); bit++; v <<= 1;
    v |= getbit(b, bit); bit++; v <<= 1;
    v |= getbit(b, bit); bit++; v <<= 1;
    v |= getbit(b, bit); bit++;
    if (v < 26) v = 'a' + v;
    else if (v < 26+26) v = 'A' + v - 26;
    else if (v < 26+26+10) v = '0' + v - 26 - 26;
    else if (v == 26+26+10) v = '-';
    else v = '.';
    b2[i] = v;
  }

  return b2;
}

void gui_add_message(void *, char *);
void add_message(chat *c, char *m)
{
  gui_add_message(c->gui, m);
}

static int random_byte(void)
{
  static int z = 0xaa;
  z *= 3;
  z++;
  return z;
}

#include <unistd.h>
void send_message(chat *c, char *m)
{
  char buf[48];
  int l = strlen(m);
  int p = 0;
  int i;

  while (l) {
    for (i = 0; i < 47 && l; i++, p++, l--) {
      if (!(m[p] & 0x80)) { buf[i] = m[p]; continue; }
      if ((m[p] & 0xe0) == 0xc0) {
        /* utf8 2 bytes */
        if (l < 2) goto invalid_utf8;
        if ((m[p+1] & 0xc0) != 0x80) goto invalid_utf8;
        if (i > 45) break;
        buf[i] = m[p];
        i++; p++; l--;
        buf[i] = m[p];
        continue;
      } else if ((m[p] & 0xf0) == 0xe0) {
        int v;
        /* utf8 3 bytes */
        if (l < 3) goto invalid_utf8;
        if ((m[p+1] & 0xc0) != 0x80) goto invalid_utf8;
        if ((m[p+2] & 0xc0) != 0x80) goto invalid_utf8;
        v = ((m[p] & 0xf) << 4) | ((m[p+1] & 0x3c) >> 2);
        if (v < 0x08) goto invalid_utf8;
        if (i > 44) break;
        buf[i] = m[p];
        i++; p++; l--;
        buf[i] = m[p];
        i++; p++; l--;
        buf[i] = m[p];
        continue;
      } else if ((m[p] & 0xf8) == 0xf0) {
        int v;
        /* utf8 4 bytes */
        if (l < 4) goto invalid_utf8;
        if ((m[p+1] & 0xc0) != 0x80) goto invalid_utf8;
        if ((m[p+2] & 0xc0) != 0x80) goto invalid_utf8;
        if ((m[p+3] & 0xc0) != 0x80) goto invalid_utf8;
        v = ((m[p] & 0x07) << 2) | ((m[p+1] & 0x30) >> 4);
        if (v < 0x01 || v > 0x10) goto invalid_utf8;
        if (i > 43) break;
        buf[i] = m[p];
        i++; p++; l--;
        buf[i] = m[p];
        i++; p++; l--;
        buf[i] = m[p];
        i++; p++; l--;
        buf[i] = m[p];
        continue;
      }
invalid_utf8:
      buf[i] = '.';
    }
    buf[i] = 0; i++;
    for (; i < 48; i++) buf[i] = random_byte();
    c->send(c, buf);
    if (l) sleep(1);
  }
}
