/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#include "gui.h"

#include "defs.h"



#include <string.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <sys/select.h>

#include "queue.h"

gpointer thread_flash(gpointer data)
{
  chat *c = data;
  Display *d;
  Window w;
  XSetWindowAttributes att;
  XEvent ev;
  struct timeval tout;
  int i;
  XColor col, col2;

  d = XOpenDisplay(0);
  if (!d) R;

  if (XAllocNamedColor(d, DefaultColormap(d, DefaultScreen(d)),
                       c->flash_color, &col, &col2) == FALSE)
  {
    LOG("cannot allocate color %s, switching to white\n", c->flash_color);
    col.pixel = WhitePixel(d, DefaultScreen(d));
  }

  att.override_redirect = True;
  att.event_mask = StructureNotifyMask;
  att.background_pixel = col.pixel;
  w = XCreateWindow(d, DefaultRootWindow(d), c->flash_x, c->flash_y,
                    c->flash_width, c->flash_height, 0,
                    DefaultDepth(d, DefaultScreen(d)), InputOutput,
                    DefaultVisual(d, DefaultScreen(d)),
                    CWBackPixel | CWEventMask | CWOverrideRedirect, &att);
  for (i = 0; i < c->flash_count; i++) {
    XMapWindow(d, w);
    while (1) {
      XNextEvent(d, &ev);
      if (ev.type == MapNotify) break;
    }
    tout.tv_sec = 0;
    tout.tv_usec = c->flash_on * 1000;
    select(0, 0, 0, 0, &tout);

    XUnmapWindow(d, w);
    while (1) {
      XNextEvent(d, &ev);
      if (ev.type == UnmapNotify) break;
    }
    tout.tv_sec = 0;
    tout.tv_usec = c->flash_off * 1000;
    select(0, 0, 0, 0, &tout);
  }

  XCloseDisplay(d);

  return 0;
}

void gui_flash(chat *c)
{
  if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((gui*)c->gui)->flash)))
    return;
  if (!g_thread_create(thread_flash, c, FALSE, 0)) R;
}

void acquire_gui(void)
{
  gdk_threads_enter();
}

void release_gui(void)
{
  gdk_flush();
  gdk_threads_leave();
}

void gui_passphrase(passphrase *p)
{
  const char *t = gtk_entry_get_text(GTK_ENTRY(p->t));
  char *t2;
  int l = strlen(t);
  if (!l) return;
  p->c->passphrase = strdup(t); if (!p->c->passphrase) R;
  /* try to clear passphrase from gtk memory (does it work?) */
  t2 = malloc(l+1); if (!t2) R;
  memset(t2, ' ', l); t2[l] = 0;
  gtk_entry_set_text(GTK_ENTRY(p->t), t2);
  free(t2);
  gtk_widget_destroy(p->w);
  gtk_main_quit();
}

gpointer send_thread(gpointer _this)
{
  gui *this = _this;
  char *z;

more:
  g_mutex_lock(this->c->data_mutex);
  if (empty_queue(&this->c->send_queue)) {
    this->c->send_over(this->c);
    this->c->send_running = 0;
    g_mutex_unlock(this->c->data_mutex);
    return 0;
  }
  z = dequeue(&this->c->send_queue);
  g_mutex_unlock(this->c->data_mutex);

  g_mutex_lock(this->c->network_mutex);
  send_message(this->c, z);
  free(z);
  g_mutex_unlock(this->c->network_mutex);

  sleep(1);
  goto more;
}

void gui_send(gui *g)
{
  const char *t;
  int l;
  char *z;
  int i;
  t = gtk_entry_get_text(GTK_ENTRY(g->down));
  l = strlen(t);
  if (!l) return;

  z = malloc(l+1); if (!z) R;
  for (i = 0; i < l; i++)
    if ((unsigned char)t[i] < 32) z[i] = '.'; else z[i] = t[i];
  z[i] = 0;

  gtk_entry_set_text(GTK_ENTRY(g->down), "");

  g_mutex_lock(g->c->data_mutex);
  enqueue(&g->c->send_queue, z);
  if (g->c->send_running) {
    g_mutex_unlock(g->c->data_mutex);
    return;
  }
  g->c->send_running = 1;
  g_mutex_unlock(g->c->data_mutex);

  if (!g_thread_create(send_thread, g, FALSE, 0)) R;
}

gpointer update_thread(gpointer _this)
{
  gui *this = _this;

  g_mutex_lock(this->c->network_mutex);
  this->c->poll(this->c);
  g_mutex_unlock(this->c->network_mutex);

  g_mutex_lock(this->c->data_mutex);
  this->c->update_running = 0;
  g_mutex_unlock(this->c->data_mutex);

  return 0;
}

gboolean gui_timer(gpointer data)
{
  gui *this = data;
  LOG("gui timer called\n");
  g_mutex_lock(this->c->data_mutex);
  if (this->c->update_running || this->c->send_running) {
    g_mutex_unlock(this->c->data_mutex);
    this->update_timer_running = 0;
    LOG("gui timer return FALSE, but did nothing (up %d send %d)\n",
        this->c->update_running, this->c->send_running);
    return FALSE;
  }
  this->c->update_running = 1;
  g_mutex_unlock(this->c->data_mutex);
  if (!g_thread_create(update_thread, this, FALSE, 0)) R;
  this->update_timer_running = 0;
  LOG("gui timer return FALSE, after creating update thread\n");
  return FALSE;
}

void gui_update_timer_start(void *data, int delay)
{
  gui *g = data;
  LOG("gui_update_timer_start called delay %d\n", delay);
  if (g->update_timer_running) g_source_remove(g->timeout_id);
  g->timeout_id = g_timeout_add(delay * 1000, gui_timer, g);
  LOG("timeout_id = %u\n", g->timeout_id);
  g->update_timer_running = 1;
}

gboolean gui_blinker(gpointer data)
{
  gui *this = data;
  if (gtk_window_is_active(GTK_WINDOW(this->w))) {
    gtk_window_set_title(GTK_WINDOW(this->w), "");
    this->is_blinking = 0;
    return FALSE;
  }
  if (this->is_blinking == 1) {
    gtk_window_set_title(GTK_WINDOW(this->w), "NEW MESSAGE");
    this->is_blinking = 2;
  } else {
    gtk_window_set_title(GTK_WINDOW(this->w), "");
    this->is_blinking = 1;
  }
  return TRUE;
}

void gui_add_message(gui *g, char *t)
{
  GtkTextBuffer *tb;
  GtkTextIter i;

  tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(g->up));
  gtk_text_buffer_get_end_iter(tb, &i);
  gtk_text_buffer_insert(tb, &i, "\n", -1);
  gtk_text_buffer_insert(tb, &i, t, -1);

#if 0
  gtk_text_buffer_get_end_iter (tb, &i);
  gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(g->up), &i, 0.0, FALSE, 0, 0);
#endif
  gui_flash(g->c);

  if (!gtk_window_is_active(GTK_WINDOW(g->w)) && !g->is_blinking) {
    g->is_blinking = 1;
    g_timeout_add(500, gui_blinker, g);
  }
}

static void gui_scroll(GtkAdjustment *v, gui *this)
{
  gtk_adjustment_set_value(v, v->upper-v->page_size);
}


static void _1(GtkEntry *_widget, gui *this)
{
  {gui_send(this);}
}

static void _4(GtkButton *_widget, gui *this)
{
  {
    /* erase keys before exit */
    memset(this->c->key1.v, 0, 32);
    memset(this->c->key2.v, 0, 32);
    exit(0);
  }
}

/* returns -1 on error, 0 if everything is fine */
int init_gui(gui *this, chat *c)
{
  GtkWidget *_0;
  GtkWidget *_7;
  GtkWidget *_2;
  GtkWidget *_3;
  GtkWidget *_5;
  GtkWidget *_6;

  {
    this->c = c;
    this->is_blinking = 0;
    this->update_timer_running = 0;
  }

  this->w = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(this->w, 600, 400);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->w),
        this->w, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 0);
  _7 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_7),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_7),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_7),
      GTK_CORNER_TOP_LEFT);
  this->down = gtk_entry_new();
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 10");
    gtk_widget_modify_font(this->down, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->flash = gtk_check_button_new();
  _2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_2), "_F");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 10");
    gtk_widget_modify_font(_2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->quit = gtk_button_new();
  _3 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_3), "_Quit");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 10");
    gtk_widget_modify_font(_3, _font_desc);
    pango_font_description_free(_font_desc);
  }
  _5 = gtk_hbox_new(FALSE, 0);
  _6 = gtk_hbox_new(FALSE, 0);
  this->up = gtk_text_view_new();
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 10");
    gtk_widget_modify_font(this->up, _font_desc);
    pango_font_description_free(_font_desc);
  }

  gtk_container_add(GTK_CONTAINER(this->w), _0);
  gtk_box_pack_start(GTK_BOX(_0), _5, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_0), _6, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_7), this->up);
  gtk_container_add(GTK_CONTAINER(this->flash), _2);
  gtk_container_add(GTK_CONTAINER(this->quit), _3);
  gtk_box_pack_start(GTK_BOX(_5), _7, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_6), this->down, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_6), this->flash, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_6), this->quit, FALSE, FALSE, 0);


  this->down_activate = g_signal_connect(this->down, "activate", G_CALLBACK(_1), this);

  this->quit_clicked = g_signal_connect(this->quit, "clicked", G_CALLBACK(_4), this);

  {
    this->timeout_id = g_timeout_add(1000, gui_timer, this);
    this->update_timer_running = 1;
    gtk_text_view_set_editable(GTK_TEXT_VIEW(this->up), FALSE);
    gtk_widget_grab_focus(this->down);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(this->flash), TRUE);
#if GTK_MINOR_VERSION >= 18
    gtk_widget_set_can_focus(this->up, FALSE);
    gtk_widget_set_can_focus(this->flash, FALSE);
    gtk_widget_set_can_focus(this->quit, FALSE);
#endif
    gtk_window_set_title(GTK_WINDOW(this->w), "");
    g_signal_connect(gtk_scrolled_window_get_vadjustment(
                       GTK_SCROLLED_WINDOW(gtk_widget_get_parent(this->up))),
                     "changed", G_CALLBACK(gui_scroll), this);
  }

  return 0;
}

static void _9(GtkEntry *_widget, passphrase *this)
{
  {gui_passphrase(this);}
}

/* returns -1 on error, 0 if everything is fine */
int init_passphrase(passphrase *this, chat *c)
{
  GtkWidget *_8;
  GtkWidget *_10;
  GtkWidget *_11;

  { this->c = c; }

  this->w = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(this->w, 400, -1);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->w),
        this->w, &_geo, GDK_HINT_MIN_SIZE);
  }
  _8 = gtk_vbox_new(FALSE, 0);
  this->t = gtk_entry_new();
  this->l = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->l), "Pass phrase (and press enter):");
  _10 = gtk_hbox_new(FALSE, 0);
  _11 = gtk_hbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->w), _8);
  gtk_box_pack_start(GTK_BOX(_8), _10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_8), _11, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_10), this->l, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_11), this->t, TRUE, TRUE, 0);


  this->t_activate = g_signal_connect(this->t, "activate", G_CALLBACK(_9), this);

  return 0;
}

