#include "buffer.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

void init_buffer(do_buf *b)
{
  b->data = 0;
  b->size = b->maxsize = 0;
}

void free_buffer(do_buf *b)
{
  if (b->maxsize) free(b->data);
  init_buffer(b);
}

void reset_buffer(do_buf *b)
{
  b->size = 0;
}

void add_buffer(do_buf *b, char *d, int l)
{
  if (b->size + l > b->maxsize) {
    b->maxsize += l + 2048;
    b->data = realloc(b->data, b->maxsize);
    if (!b->data) {
      printf("PANIC: out of memory in add_buffer\n");
      exit(1);
    }
  }
  memcpy(b->data+b->size, d, l); /* CHECKED */
  b->size += l;
}

void add_buffer_char(do_buf *b, char c)
{
  if (b->size == b->maxsize) {
    b->maxsize += 65536;
    b->data = realloc(b->data, b->maxsize);
    if (!b->data) {
      printf("PANIC: out of memory in add_buffer\n");
      exit(1);
    }
  }
  b->data[b->size] = c;
  b->size++;
}

void add_buffer_s(do_buf *b, char *s)
{
  while (*s) { add_buffer_char(b, *s); s++; }
}
