#include "../defs.h"
#include "defs.h"
#include "../mathim/buffer.h"

#include <curl/curl.h>
#include <string.h>
#include <stdlib.h>

static do_buf recdata;
static do_buf snddata;

static size_t get_data_cb(void *buffer, size_t size, size_t nmemb, void *userp)
{
  add_buffer(&recdata, buffer, size*nmemb);
  return size * nmemb;
}

static void _connect(struct chat *c)
{
}

static void _poll(struct chat *c)
{
  server_data *d = (server_data *)c->server_data;
  char url[512];
  CURL *h;
  CURLcode ret;
  int nb;

  /* send update */
  h = curl_easy_init(); if (!h) R;
  reset_buffer(&recdata);
  if (strlen(d->base_url) > 500) R;
  sprintf(url, "%s", d->base_url);
  curl_easy_setopt(h, CURLOPT_URL, url);
  curl_easy_setopt(h, CURLOPT_WRITEFUNCTION, get_data_cb);
  ret = curl_easy_perform(h); if (ret) R;
  add_buffer_char(&recdata, 0);
  curl_easy_cleanup(h);
  LOG("%s\n", recdata.data);
  acquire_gui();
  nb = extract_messages(c, recdata.data);
  if (nb)
    d->no_activity = 0;
  else if (d->no_activity < d->switch_delay)
    d->no_activity += d->fast_delay;
  if (d->no_activity >= d->switch_delay) {
    LOG("slow delay, no activity is big\n");
    gui_update_timer_start(c->gui, d->slow_delay);
  } else {
    LOG("fast delay, no activity is small\n");
    gui_update_timer_start(c->gui, d->fast_delay);
  }
  release_gui();
}

static void _disconnect(struct chat *c)
{
}

static void _send(struct chat *c, char *m)
{
  server_data *d = (server_data *)c->server_data;
  CURL *h;
  CURLcode ret;
  int i;

  m = encode_message(c, m);
  LOG("SSSSSSSSSSSSSSSSSSSSSS: %s\n", m);

  /* send 'send' */
  reset_buffer(&snddata);
  add_buffer_s(&snddata, d->base_url);
  add_buffer_s(&snddata, "?m=");
  add_buffer_char(&snddata, '_');
  add_buffer_char(&snddata, '_');
  for (i = 0; i < 92; i++) add_buffer_char(&snddata, m[i]);
  add_buffer_char(&snddata, 0);
  h = curl_easy_init(); if (!h) R;
  reset_buffer(&recdata);
  curl_easy_setopt(h, CURLOPT_URL, snddata.data);
  curl_easy_setopt(h, CURLOPT_WRITEFUNCTION, get_data_cb);
  ret = curl_easy_perform(h); if (ret) R;
  add_buffer_char(&recdata, 0);
  curl_easy_cleanup(h);
  LOG("%s\n", recdata.data);
  acquire_gui();
  extract_messages(c, recdata.data);
  release_gui();
}

static void _send_over(struct chat *c)
{
  server_data *d = c->server_data;
  acquire_gui();
  d->no_activity = 0;
  gui_update_timer_start(c->gui, d->fast_delay);
  release_gui();
}

static int _new_message(chat *c, const char *m)
{
  server_data *d = c->server_data;
  int i;
  for (i = 0; i < 16; i++)
    if (!memcmp(d->recent_messages[i], m, 69)) return 0;
  memcpy(d->recent_messages[d->recent_pos], m, 69);
  d->recent_pos++;
  d->recent_pos &= 15;
  return 1;
}

void s_server_init(chat *c)
{
  server_data *d;
  CURLcode ret;
  ret = curl_global_init(CURL_GLOBAL_ALL); if (ret) R;
  init_buffer(&recdata);
  init_buffer(&snddata);
  c->connect = _connect;
  c->poll = _poll;
  c->disconnect = _disconnect;
  c->send = _send;
  c->send_over = _send_over;
  c->new_message = _new_message;
  d = malloc(sizeof(server_data)); if (!d) R;
  c->server_data = d;
  d->base_url = get_option(&c->options, "connection.s.base_url");
  sscanf(get_option(&c->options, "connection.s.fast"), "%d",
         &d->fast_delay);
  sscanf(get_option(&c->options, "connection.s.slow"), "%d",
         &d->slow_delay);
  sscanf(get_option(&c->options, "connection.s.switch"), "%d",
         &d->switch_delay);
  d->no_activity = 0;
  if (d->fast_delay < 1 || d->fast_delay > 100 ||
      d->slow_delay < 1 || d->slow_delay > 100 ||
      d->switch_delay < 1 || d->switch_delay > 100) {
    printf("bad s delays in configuration file\n");
    exit(1);
  }
  d->recent_pos = 0;
  memset(d->recent_messages, ' ', 16*69);
}
